int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];
    uint32_t i, num;
    int num_cols;

    num_cols = 2 + sizeof(uint32_t) + (size - 1) / 3;

    memset(buf, 0, sizeof(buf));

    num = 0;
    for (i = 0; i < size; i++) {
        if (isdigit(in_data[i])) {
            snprintf(buf + num_cols, sizeof(buf) - num_cols, " %c", in_data[i]);
            num += 1;
        } else if (isprint(in_data[i])) {
            snprintf(buf + num_cols, sizeof(buf) - num_cols, " %c", in_data[i]);
            num += 1;
        } else {
            snprintf(buf + num_cols, sizeof(buf) - num_cols, " .");
        }
        num_cols += strlen(buf + num_cols);
    }
    *out = strdup(buf);
    return num;
}