int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];
    while (size > 0 && *in_data) {
        if (*in_data == 0xd) {
            if (*(in_data + 1) == 0xd) {
                in_data += 2;
                size -= 2;
                continue;
            }
            else {
                return -1;
            }
        }
        if (*in_data == 0xa) {
            in_data++;
            size--;
            continue;
        }
        if (*in_data == 0x9) {
            in_data++;
            size--;
            continue;
        }
        if (*in_data == 0x8) {
            in_data++;
            size--;
            continue;
        }
        if (*in_data == 0x7) {
            in_data++;
            size--;
            continue;
        }
        if (*in_data == 0x6) {
            in_data++;
            size--;
            continue;
        }
        if (*in_data == 0x5) {
            in_data++;
            size--;
            continue;
        }
        if (*in_data == 0x4) {
            in_data++;
            size--;
            continue;
        }
        if (*in_data == 0x3) {
            in_data++;
            size--;
            continue;
        }
        if (*in_data == 0x2) {
            in_data++;
            size--;
            continue;
        }
        if (*in_data == 0x1) {
            in_data++;
            size--;
            continue;
        }
        if (*in_data == 0x0) {
            in_data++;
            size--;
            continue;
        }
        in_data++;
        size--;
        sprintf(buf, "\x1b%02x", *in_data);
        for (size_t i = 0; i < 8; i++) {
            if (strlen(buf) < size) {
                sprintf(out + i*2, "%c", buf[strlen(buf)]);
            }
        }
    }
    return 0;
}