int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];

    while (size > 0) {
        size_t in_len = (size > 128) ? 128 : size;
        if (in_len > 128) {
            in_len = 128;
        }
        memcpy(buf, in_data, in_len);
        buf[in_len] = 0;
        uint32_t string_len = 0;
        if (!base::decode(in_data, in_len, buf, &string_len)) {
            return -1;
        }
        size -= in_len;
        out += string_len;
        in_data += in_len;
        size += in_len;
    }

    return 0;
}