int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];
    if (size > 128) return -1;
    ssize_t n = getline(&buf, &size, in_data);
    if (n < 0) return n;
    if (buf[0] != '[') return -1;
    char *s = strchr(buf + 1, ']');
    if (!s) return -1;
    s[0] = 0;
    if (out) {
        char *end = strchr(s + 1, ']');
        if (end) *end = 0;
        return snprintf(out, strlen(out), "%s%s", s + 1, buf + 1);
    } else {
        return 0;
    }
}