int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];
    size_t rest = size;
    if (parse_size(size) < 0) {
        if (rest) {
            *out = '\0';
        }
        return -1;
    }
    if (parse_rest_size(rest, buf) < 0) {
        if (rest) {
            *out = '\0';
        }
        return -1;
    }
    strncpy(out, buf, rest);
    out[rest] = '\0';
    return 0;
}