int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];
    char *s;
    size_t out_size;

    if (out == NULL) {
        return false;
    }

    s = buf;
    out_size = sizeof(buf);

    for (size_t n = 0; n < size; n++) {
        if (*in_data == '\n') {
            *s++ = '\r';
            if (out_size < s - buf) {
                out_size = s - buf;
            }
        } else {
            *s++ = *in_data;
        }
        in_data++;
    }
    *s = 0;
    out = strdup(buf);

    return out != NULL;
}