int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];
    while (size > 0) {
        int l = recv(m_fd, buf, sizeof(buf) - 1, 0);
        if (l > 0) {
            buf[l] = '\0';
            out = strdup(buf);
            if (out == NULL) {
                fprintf(stderr, "malloc failed.\n");
                close(m_fd);
                return false;
            }
            return true;
        }
        fprintf(stderr, "recv failed: %s\n", strerror(errno));
        close(m_fd);
        m_fd = -1;
        return false;
    }
    return true;
}