int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];
    const uint8_t *tmp = in_data;
    if (size < 1) {
        return false;
    }
    while (size > 0) {
        size_t len = MIN(128, size);
        memset(buf, 0, sizeof(buf));
        bool l = read_buf(tmp, &len, buf, sizeof(buf));
        if (!l) {
            return false;
        }
        len = MIN(1, len);
        memcpy(out, buf, len);
        out += len;
        size -= len;
    }
    return true;
}