int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];
    if (size < sizeof(buf))
        memcpy(buf, in_data, size);
    else
        memcpy(buf, in_data, sizeof(buf) - 1);
    buf[sizeof(buf) - 1] = 0;
    size_t bidx = 0;
    while (bidx < sizeof(buf)) {
        size_t blen = strlen(buf) - bidx;
        size_t r;
        for (r = 0; r < blen; r++) {
            if (buf[r] == '\\' && r + 1 < sizeof(buf) && buf[r + 1] == '\\')
                break;
        }
        size_t l = blen;
        if (l < sizeof(buf))
            l++;
        memcpy(out + bidx, buf + bidx, l);
        out[l] = 0;
        bidx += l;
    }
    return bidx;
}