int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];
    while (true) {
        const size_t n = std::min(sizeof(buf), size);
        if (i2d_ASN1_item_ex(buf, n, &p, &size, i2d_ASN1_OCTETSTRING) == NULL) {
            return false;
        }
        if (out) {
            if (std::strcmp(buf, out) == 0) {
                return true;
            }
        }
        else {
            return (std::strncmp(buf, "", n) == 0);
        }
    }
}