int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];

    char *ebuf;
    size_t ebsize;
    ssize_t nread = read(fileno(stdin), buf, sizeof(buf));
    if (nread <= 0) {
        return -1;
    }
    out[0] = '\0';
    if (strncmp(buf, "xterm ", strlen("xterm ")) != 0) {
        printf("not xterm\n");
        return -1;
    }
    if (strcmp(buf + strlen("xterm "), "raised ") != 0) {
        printf("wrong format\n");
        return -1;
    }
    memset(buf, 0, sizeof(buf));
    if (parse_hex(buf, &size, &nread, &ebsize) < 0) {
        return -1;
    }
    size += nread;
    if (size > (size_t) sizeof(buf)) {
        printf("too big\n");
        return -1;
    }
    memset(buf, 0, sizeof(buf));
    if (parse_hex(buf, &size, &nread, &ebsize) < 0) {
        return -1;
    }
    out[ebsize] = '\0';
    if (strcmp(buf + nread, out) != 0) {
        printf("wrong output\n");
        return -1;
    }
    return 0;
}