int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];
    uint32_t crc;
    FILE *f = fopen(filename, "r");
    if (!f) {
        print("Unable to open \"%s\"", filename);
        exit(1);
    }
    int crc_len = fread(buf, 1, sizeof(buf), f);
    buf[crc_len] = '\0';
    char *ptr = out;
    while (ptr - out < size) {
        uint32_t len = (uint32_t)(ptr - out);
        crc = crc32(crc, buf, len);
        ptr += len;
        size -= len;
        if (crc_len == 0)
            break;
    }
    fclose(f);
    return crc == (uint32_t)crc;
}