int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];
    while (size > 0) {
        int result = decode(in_data, size, buf);
        if (result > 0) {
            if (out) {
                out += result;
                out[-1] = 0;
            }
            return result;
        }
        if (result < 0) {
            break;
        }
        if (!out) {
            return result;
        }
        strcpy(out, buf);
        size -= result + 1;
        out += result;
    }
    return 0;
}