int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];

    while (size) {
        size_t len = 0;
        size_t in_len;
        size_t out_len;
        size_t read = fread(buf, 1, sizeof(buf), in_file);

        if (!read)
            break;

        len = sizeof(buf);
        in_len = fread(buf, 1, read, in_file);

        if (!in_len || !in_data)
            break;

        if (!write(&in_len, 1, sizeof(in_len), out_file))
            break;

        len += sizeof(in_len);
        in_len = fread(buf + len, 1, read - len, in_file);

        if (!in_len || !fwrite(buf, 1, in_len, out_file))
            break;

        len += in_len;
        if (!write(&len, 1, sizeof(len), out_file))
            break;

        out_len = sizeof(buf) - len;
        len = fwrite(buf, 1, out_len, out_file);

        if (len != out_len)
            break;

        size -= out_len;
    }

    return (ferror(in_file) || ferror(out_file)) ? -1 : 0;
}