int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];
    char *p = buf;
    size_t len = 0;

    int r = parse_binary(in_data, size, &p, &len);
    if (r < 0) {
        return r;
    }

    *out = 0;
    if (len) {
        r = asprintf(out, "%"PRIu64, (uint64_t)r);
        if (r < 0) {
            return -1;
        }
    }
    return 0;
}