int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];
    memset(buf, 0, sizeof(buf));
    uint8_t *start_buf = buf;
    for (size_t i = 0; i < size;) {
        size_t remain = buf + sizeof(buf) - start_buf;
        if (remain > i + 1) {
            memcpy(start_buf, in_data + i, remain - i);
            start_buf[remain - i] = 0;
        } else {
            memcpy(start_buf, in_data + i, sizeof(buf) - i);
            i += sizeof(buf) - i;
            i += buf[0] != 0 ? 1 : 0;
        }

        size_t n = read(infd, start_buf, sizeof(buf) - (size - remain));
        if (n == -1) {
            perror("read()");
            return -1;
        } else if (n == 0) {
            break;
        }
        if (remain == sizeof(buf) - i) {
            memcpy(in_data, start_buf, remain);
            return 1;
        } else if (remain > n) {
            memcpy(in_data + n, start_buf, remain);
            return 1;
        }
        memcpy(in_data + n, start_buf, remain);
    }

    return 0;
}