import json

def find_match_brace(s):
    first_brace = s.find('{')
    braces = 1
    for i in range(first_brace+1, len(s)):
        if s[i] == '{': braces += 1
        if s[i] == '}': braces -= 1
        if braces == 0: break
    if braces != 0: return -1
    else: return i+1

for i,line in enumerate(open('prompt_buf.json.out')):
    code = json.loads(line)['text']
    brace = find_match_brace(code)
    if brace == -1:
        print(f"No brace found for sample {i}")
        continue
    fname = f"{i:06}.c"
    f = open(fname,"w")
    f.write(code[:brace])
    f.close()
    print(f"Saved {fname}")
