int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];

    size_t bytes_read = 0;
    while (bytes_read < size && buf[bytes_read] != 0)
        buf[bytes_read++] = in_data[bytes_read++];

    if (bytes_read == size || 0 == memcmp(in_data, buf, bytes_read))
        return bytes_read;

    return bytes_read < size ? -1 : -2;
}