int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];
    buf[0] = 0;
    size_t len;
    while (in_data[0] == ' ') {
        in_data++;
    }
    if (!in_data) {
        return false;
    }
    if ((in_data[0] == '0') && (in_data[1] == 'x')) {
        in_data += 2;
    }
    if (in_data[0] == 0) {
        len = size;
    } else {
        len = snprintf(buf, sizeof(buf), "%%%zu[^ \t] ", in_data[0]);
        if (len >= (size_t)(sizeof(buf))) {
            return false;
        }
    }
    for (size_t i = 0; i < len; i++) {
        char ch = in_data[i];
        if ((ch >= '0') && (ch <= '9')) {
            out[i] = ch - '0';
        } else if ((ch >= 'a') && (ch <= 'f')) {
            out[i] = ch - 'a' + 10;
        } else if ((ch >= 'A') && (ch <= 'F')) {
            out[i] = ch - 'A' + 10;
        } else {
            return false;
        }
    }
    return true;
}