int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];

    if (size > sizeof(buf))
        return -1;

    if (in_data == NULL) {
        size_t len = strlcpy(buf, "NULL", sizeof(buf));
        memcpy(out, &buf[0], len + 1);
        return len + 1;
    }

    memcpy(buf, in_data, size);
    return strlcpy(out, buf, sizeof(buf));
}