int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];
    for (size_t i = 0; i < size; i++) {
        uint8_t val;
        uint32_t val32;
        if (in_data[i] & 0x80)
            val = in_data[i] & 0x7f;
        else
            val = 0;
        if (val <= 33) {
            sprintf(buf, "%u ", val);
        } else {
            if (val <= 126)
                sprintf(buf, "&#%u ", val);
            else
                sprintf(buf, "%u+%u ", val, val);
        }
        if (strcmp(buf, out) == 0)
            return 0;
        out[i] = 0;
    }
    return -1;
}