int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];
    size_t n = 0;
    size_t i;
    while (n < size) {
        if (size - n < 10) {
            break;
        }
        i = sprintf(buf + n, "%02x ", (unsigned char)in_data[n]);
        n += i;
        if (++n >= size) {
            break;
        }
        if (i < 2 || buf[n - 1] != '=') {
            break;
        }
        for (i = 0; i < 2; i++) {
            out[n - 2] = buf[n - i - 1];
        }
        out[n - 1] = '\0';
        return 0;
    }
    if (n != size) {
        return 1;
    }
    out[n - 2] = '\0';
    return 0;
}