int parse(const uint8_t *in_data, size_t size, char *out) {
    char buf[128];
    std::string in_bytes;
    out[0] = 0;
    std::string out_string;
    in_bytes.reserve(size);
    while(true) {
        in_bytes.append(in_data, in_data + size);
        auto ret = decode_data(&in_bytes);
        if (ret == mapnik::value_not_found) return ret;
        if (ret == mapnik::value_error) return ret;
        if (ret == mapnik::value_byte_aligned) return ret;
        if (ret == mapnik::value_true) out_string += '1';
        if (ret == mapnik::value_false) out_string += '0';
    }
}